#!bin/sh
VERSION=src/autoversion.h
export LC_ALL=C
export LANGUAGE=C
export LANG=C
export CHARSET="iso8859-1"

if [ -f $VERSION ]; then
	echo "Recreating autoversion.h"
	rm $VERSION
else
	echo "Creating autoversion.h"
fi

#get path to gamedata provided my make
BUILD_DATADIR=$1

#get svn version if we have any
BUILD_REVISION="unknown"
BUILD_SVNURL="unknown"
cd ./src
if [ -d .svn ]; then
	echo "Found .svn in src"
	BUILD_REVISION=`svn info | grep vision | awk -F': ' '{print $NF}'`
	BUILD_SVNURL=`svn info | grep URL | awk -F': ' '{print $NF}'`
else
	echo "Couldn't read svn info from src/.svn"
fi
cd ../

#get date
BUILD_DATE=`LANG=en_EN date +"%b %m %Y %T"`
#get some more informations about host
BUILD_UNAME_A=`uname -a`
BUILD_UNAME_M=`uname -m`
BUILD_UNAME_N=`uname -n`
BUILD_UNAME_R=`uname -r`
BUILD_UNAME_S=`uname -s`
BUILD_UNAME_V=`uname -v`
BUILD_UNAME_SRM=`uname -srm`
BUILD_USER=`whoami`

echo "/***************************************************************************" >> $VERSION
echo " *      Mechanized Assault and Exploration Reloaded Projectfile            *" >> $VERSION
echo " *                                                                         *" >> $VERSION
echo " *   autoversion.h - Generated by buildinfo.sh.                            *" >> $VERSION
echo " *                                                                         *" >> $VERSION
echo " *   This is an automatically generated file. Do not modify this file,     *" >> $VERSION
echo " *   changes will be lost the next time make gets invoked!                 *" >> $VERSION
echo " *                                                                         *" >> $VERSION
echo " *   This program is free software; you can redistribute it and/or modify  *" >> $VERSION
echo " *   it under the terms of the GNU General Public License as published by  *" >> $VERSION
echo " *   the Free Software Foundation; either version 2 of the License, or     *" >> $VERSION
echo " *   (at your option) any later version.                                   *" >> $VERSION
echo " *                                                                         *" >> $VERSION
echo " *   This program is distributed in the hope that it will be useful,       *" >> $VERSION
echo " *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *" >> $VERSION
echo " *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *" >> $VERSION
echo " *   GNU General Public License for more details.                          *" >> $VERSION
echo " *                                                                         *" >> $VERSION
echo " *   You should have received a copy of the GNU General Public License     *" >> $VERSION
echo " *   along with this program; if not, write to the                         *" >> $VERSION
echo " *   Free Software Foundation, Inc.,                                       *" >> $VERSION
echo " *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *" >> $VERSION
echo " ***************************************************************************/" >> $VERSION
echo "" >> $VERSION
echo "#define HAVE_AUTOVERSION_H 1" >> $VERSION
echo "" >> $VERSION
echo "#ifdef RELEASE" >> $VERSION
echo "	#define PACKAGE_REV \"Releaseversion\"" >> $VERSION
echo "#else" >> $VERSION
echo "	#define PACKAGE_REV \"SVN Rev $BUILD_REVISION\"" >> $VERSION
echo "#endif" >> $VERSION
echo "" >> $VERSION
echo "#define BUILD_SVNURL \"$BUILD_SVNURL\"" >> $VERSION
echo "#define BUILD_DATADIR \"$BUILD_DATADIR\"" >> $VERSION
echo "#define MAX_BUILD_DATE \"$BUILD_DATE\"" >> $VERSION
echo "#define BUILD_UNAME_A \"$BUILD_UNAME_A\"" >> $VERSION
echo "#define BUILD_UNAME_M \"$BUILD_UNAME_M\"" >> $VERSION
echo "#define BUILD_UNAME_N \"$BUILD_UNAME_N\"" >> $VERSION
echo "#define BUILD_UNAME_R \"$BUILD_UNAME_R\"" >> $VERSION
echo "#define BUILD_UNAME_S \"$BUILD_UNAME_S\"" >> $VERSION
echo "#define BUILD_UNAME_V \"$BUILD_UNAME_V\"" >> $VERSION
echo "#define BUILD_UNAME_SRM \"$BUILD_UNAME_SRM\"" >> $VERSION
echo "#define BUILD_USER \"$BUILD_USER\"" >> $VERSION


